/*
* Copyright (c) 2006-2007 Erin Catto http:
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked, and must not be
* misrepresented the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

goog.provide('box2d.CircleDef');

goog.require('box2d.Shape');
goog.require('box2d.ShapeDef');



/**
 * @constructor
 * @extends {box2d.ShapeDef}
 */
box2d.CircleDef = function() {
  goog.base(this);
  this.type = box2d.ShapeDef.Type.circleShape;
  this.radius = 1.0;
};
goog.inherits(box2d.CircleDef, box2d.ShapeDef);

box2d.CircleDef.prototype.ComputeMass = function(massData) {
  massData.mass = this.density * box2d.Settings.b2_pi * this.radius * this.radius;
  massData.I = 0.5 * (massData.mass) * this.radius * this.radius;
};
